<component-section>
  <div slot="title">🗂️ Data</div>
  <component-section>
    <div slot="title">Abstract data types</div>
    <p>
      Een <em class="term">abstract data type</em> (<em class="term">adt</em>) is een abstractie voor het bewaren van
      data met software. Het begrip adt is een afspraak om
    </p>
    <ul>
      <li>een bewaarvorm voor een bepaalde soort data overal dezelfde naam te geven,</li>
      <li>
        waarbij er minstens een bepaalde set
        <em class="term">operaties</em> op de data mogelijk moet zijn.
      </li>
    </ul>
    <p>
      Een operatie is bijvoorbeeld een element toevoegen (en die operatie heet dan bijvoorbeeld <code>insert</code> of
      <code>add</code>), of zoeken naar een element binnen de datastructuur (<code>search</code>).
    </p>
    <p>
      Kortom, een adt is dus een soort interface voor data, en de operaties erop zijn methods. Maar <em>adt</em> is een
      programmeertaalonafhankelijk concept, in tegenstelling tot <em>interface</em>.
    </p>
    <p>Deze bron van MIT legt een aantal aspecten dieper uit:</p>
    <ul>
      <li><p>Wat ‘abstract’ inhoudt bij het concept adt.</p></li>
      <li><p>In hoeverre een adt algemeen (generiek) is.</p></li>
      <li><p>Hoe in Java interfaces als adt’s gebruikt kunnen worden.</p></li>
    </ul>
    <p class="bron">
      <a href="http://web.mit.edu/6.005/www/fa14/classes/08-abstract-data-types/">Reading 8: Abstract Data Types</a>
    </p>
  </component-section>
  <component-section>
    <div slot="title">Datastructuren</div>
    <p>
      Waar een adt abstract en formeel is, is een
      <em class="term">datastructuur</em> een concrete implementatie, uitgedrukt in broncode en gebonden aan een
      concrete geheugenindeling. Adt’s kunnen op verschillende manieren worden geïmplementeerd, zelfs binnen
      programmeertalen. Het resultaat van het implementeren is een datastructuur.
    </p>
    <p>
      Een <em class="term">datastructuur</em> is opgeslagen in computergeheugen (→ data) en opgebouwd uit
      <em class="term">datatypes</em> (→ structuur). Doordat een datastructuur is opgeslagen in het geheugen, hangt de
      concrete vorm van datastructuren af van de hardware en de programmeertaal-implementatie.
    </p>
    <p>Een <em class="term">datatype</em> is bijvoorbeeld een class met data-velden, in Java.</p>
    <!-- TODO: Illustratie toevoegen over datastructuur, datatype. -->
    <p>
      Een <em class="term">primitief datatype</em> is simpeler dan zo’n class. De betekenis van primitief datatype hangt
      af van de programmeertaal, maar ‘getal’ (bijvoorbeeld <code class="lang-java">int</code>) of ‘karakter’ (<code
        class="lang-java"
        >char</code
      >) zijn bijna altijd wel beschikbaar. Simpelere data types dan primitieve bestaan nooit.
    </p>
    <p class="bron">
      The Java® Language Specification - Java SE 17 Edition
      <cite data-id="6867189/LGMREFR6" data-label="section" data-locator="4.2"></cite>
      (<a href="https://docs.oracle.com/javase/specs/jls/se17/html/jls-4.html#jls-4.2">Primitive Types and Values</a>)
    </p>
    <p>
      Een datastructuur is in broncode niet per se een class, en hoeft ook geen adt-interface te implementeren. Dat
      hangt helemaal ervan af of de programmeertaal bijvoorbeeld objectgeoriënteerd is.
    </p>
    <p>
      Een standaarddatastructuur is in deze course een datastructuur die fundamenteel en basaal is binnen de
      informatica.
    </p>
    <p>
      OpenDSA licht de verbanden toe tussen onder meer adt, datastructuur en datatype vanuit een
      programmeertaalperspectief:
    </p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/OpenDSA/Books/Everything/html/ADT.html#adt">4.1. Abstract Data Types</a>
    </p>
    <component-section>
      <div slot="title">Waarom je adt’s en datastructuren leert</div>
      <p class="praktijk">
        De standaard-adt’s waar je in dit hoofdstuk over leert beschrijven de functionaliteit van datastructuren in vele
        implementaties. Zelfs als je algoritmes niet zelf implementeert, maar alleen aanroept, moet je alsnog werken met
        hun invoer- en uitvoerdata (veelal in datastructuren). Het is dan belangrijk om te weten naar wat voor operaties
        je moet zoeken in de documentatie.
      </p>
      <p>
        De implementatiedetails in datastructuren zullen in de praktijk (grote) gevolgen hebben voor de
        prestatie-efficiëntie van een algoritme-implementatie of softwaresysteem als geheel. Daarom is het belangrijk om
        de begrippen adt en datastructuur te onderscheiden.
      </p>
      <p>
        Lists, stacks en queues zijn de belangrijkste adt’s (op de simpele/primitieve types na). Deze helpen je vooral
        om items af te lopen ‘op rij’ (sequentieel), ook wel <em>lineair</em> genoemd. Hierover leer je meer in het
        volgende.
      </p>
    </component-section>
  </component-section>
  <component-section>
    <div slot="title">De lijst/list</div>
    <p>
      De <em class="term">lijst</em> of <em id="term_list" class="term">list</em> is de adt voor een eindige, geordende
      rij van items/elementen die niet uniek hoeven te zijn.
    </p>
    <p>
      In de volgende video’s legt David Scot Taylor verscheidene adt’s en datastructuren uit op een toegankelijke
      manier.
    </p>
    <p class="bron">Lists, Iterators and Abstract Data Types</p>
    <component-video videoid="B4y8Sb2O4H0" title="Lists, Iterators and Abstract Data Types"></component-video>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/ListADT.html">Lists</a>
    </p>
    <component-section>
      <div slot="title">
        <a href="https://ans.app/digital_test/assignments/295009/routing">Itereren (op Ans)</a>
      </div>
      <component-exercise></component-exercise>
    </component-section>
    <component-section>
      <div slot="title">Waarom je lists leert</div>
      <p>
        Iedere programmeur heeft al wel eens met een list gewerkt. Zelfs een gewone array uit Java is in essentie een
        datastructuur voor een list. Die array-implementatie voldoet aan
        <a href="#term_list">de definitie van list</a>, maar sommige operaties (bijvoorbeeld aan het begin of einde
        ervan een element toevoegen) zijn standaard niet in één functie (bijvoorbeeld method) geïmplementeerd.
      </p>
    </component-section>
    <component-section>
      <div slot="title">De gelinkte lijst/linked list</div>
      <p>
        Een <em class="term">gelinkte lijst</em> of <em class="term">linked list</em> is een datastructuur voor een
        list, bestaande uit <em>nodes</em>. Een node bestaat uit het element (de inhoud) en verwijzingen naar de
        volgende en soms ook vorige node. In het laatste geval heet het een
        <em class="term">tweevoudig gelinkte lijst</em> of <em class="term">doubly-linked list</em>. De elementen staan
        niet per se opeenvolgend aansluitend in het geheugen (dus: niet lineair in het geheugen, wel lineair af te
        lopen). De verwijzingen zijn <em>pointers</em> of <em>references</em> (programmeertaalafhankelijk) naar een
        geheugenobject.
      </p>
      <p class="bron">Linked Lists</p>
      <component-video videoid="14g1YBvx8Co" title="Linked Lists"></component-video>
      <p class="bron">
        <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/ListLinked.html">Linked Lists</a>
      </p>
      <p class="bron">
        <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/ListDouble.html">Doubly Linked Lists</a>
      </p>
      <component-section class="praktijk">
        <div slot="title">Waarom je gelinkte lijsten leert</div>
        <p>
          Alle niet-embedded softwaresystemen gebruiken geheugenallocatoren voor de heap (<code class="lang-c"
            >malloc()</code
          >). De implementatie van een geheugenallocator
          <a href="http://staffwww.fullcoll.edu/aclifton/cs241/lecture-dynamic-mem-linked-lists.html"
            >gebruikt vaak gelinkte lijsten</a
          >.
        </p>
        <p>Ook de processenlijst van het Linux-besturingssysteem is gebaseerd op gelinkte lijsten .</p>
        <p>
          Gelinkte lijsten zijn een mogelijke onderliggende datastructuur voor andere datastructuren, zoals stacks,
          queues, hashtabellen en grafen.
        </p>
        <p>
          Tweevoudig gelinkte lijsten zouden gebruikt kunnen worden voor iets als een terug- en vooruitfunctie
          (bijvoorbeeld in een web browser).
        </p>
        <p>
          Gelinkte lijsten worden vaker gebruikt dan alternatieve lijsten als het aantal elementen niet bekend is of
          vast mag liggen, en willekeurige toegang tot elementen niet nodig is (bijvoorbeeld voor sorteren).
        </p>
      </component-section>
      <component-section>
        <div slot="title">
          <a href="https://ans.app/digital_test/assignments/297244/routing"
            >Gelinkte lijsten en geheugenruimte (op Ans)</a
          >
        </div>
        <component-exercise></component-exercise>
      </component-section>
      <component-section>
        <div slot="title">
          <a href="https://ans.app/digital_test/assignments/297587/routing">Sentinel node (op Ans)</a>
        </div>
        <component-exercise></component-exercise>
      </component-section>
    </component-section>
    <component-section>
      <div slot="title">De dynamische rij/dynamic array</div>
      <p>
        <em class="term">Dynamische rijen</em> of <em class="term">dynamic arrays</em> zijn ook wel bekend als
        <em class="term">vectors</em>. Dynamische rijen hebben geen vaste lengte, statische (gewone) arrays wel.
        Hierdoor zijn ze erg veelzijdig, en misschien wel de mééstgebruikte datastructuur ooit.
      </p>
      <p>
        In de volgende video’s legt David Scot Taylor dynamische rijen uit. Hij stelt de praktijk centraal, wat zijn
        uitleg voor hbo’ers erg goed maakt, vergeleken met de meer academische video’s die je her en der kan vinden.
        Zijn uitleg over geamortiseerde algoritmeanalyse hoef je trouwens niet te leren voor ADP.
      </p>
      <p class="bron">Dynamic Arrays, aka ArrayLists</p>
      <component-video videoid="0XC9lFGGpME" title="Dynamic Arrays, aka ArrayLists"></component-video>
      <component-section>
        <div slot="title">
          <a href="https://ans.app/digital_test/assignments/297594/routing">Array access (op Ans)</a>
        </div>
        <component-exercise></component-exercise>
      </component-section>
      <component-section>
        <div slot="title">
          <a href="https://ans.app/digital_test/assignments/297595/routing"
            ><code class="lang-java">ArrayList</code> versus statische rij (op Ans)</a
          >
        </div>
        <component-exercise></component-exercise>
      </component-section>
    </component-section>
  </component-section>
  <component-section>
    <div slot="title">De stapel/stack</div>
    <p>
      De adt <em class="term">stapel</em> of <em class="term">stack</em> geeft het <em>laatste ingevoegde</em> element
      als eerste terug (<em class="term">last in, first out (lifo)</em>).
    </p>
    <p class="bron">Stack Data Structure - Algorithm</p>
    <component-video videoid="niBsGw4h5yI" title="Stack Data Structure - Algorithm"></component-video>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/StackArray.html">Stacks</a>
    </p>
  </component-section>
  <component-section>
    <div slot="title">De wachtrij/queue</div>
    <p>
      De adt <em class="term">wachtrij</em> of <em class="term">queue</em> geeft het <em>vroegst ingevoegde</em> element
      als eerste terug (<em class="term">first in, first out (fifo)</em>).
    </p>
    <p class="bron">Queue Data Structure - Algorithm</p>
    <component-video videoid="jXMqVpAVyMY" title="Queue Data Structure - Algorithm"></component-video>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/Queue.html">Queues</a>
    </p>
    <component-section>
      <div slot="title">De prioriteitswachtrij/priority queue</div>
      <p>
        De adt <em class="term">prioriteitswachtrij</em> of <em class="term">priority queue</em> is qua interface
        identiek aan een queue, maar de operaties hebben een andere betekenis. In plaats van dat het
        <em>vroegst ingevoegde</em> element als eerste teruggegeven wordt, wordt telkens het <em>kleinste</em> element
        teruggegeven. Alternatief kan telkens het <em>grootste</em> element teruggegeven. Algemener gezegd, wordt
        telkens het element met de hoogste prioriteit teruggegeven.
      </p>
    </component-section>
  </component-section>
  <component-section>
    <div slot="title">Van stacks en queues naar de deque</div>
    <p>
      David Scot Taylor legt het verband uit tussen stacks, queues en een nog generiekere adt:
      <em class="term">deques</em>.
    </p>
    <p class="bron">Stacks, Queues and Double Ended Queues (Deques)</p>
    <component-video videoid="IITnvmnfi_Y" title="Stacks, Queues and Double Ended Queues (Deques)"></component-video>
  </component-section>
  <component-section>
    <div slot="title">Generic programming</div>
    <p>
      Het is optimaal om datastructuren ondanks dat ze specifieker zijn dan adt's, wèl generiek te implementeren wat
      betreft de data die erinpast, in plaats van broncode uit te schrijven voor allerlei verschillende denkbare
      itemtypes, met veel herhaling. Java is één van de programmeertalen die mogelijkheden biedt voor
      <em class="term">generic programming</em>. <em>Generic</em> betekent net als het Nederlandstalige
      <em>generiek</em> ‘algemeen’. Generiek is de tegenhanger van <em>specifiek</em>. Generic programming betekent dat
      je binnen een programmeertaal die dat ondersteunt,
      <em>regels kan programmeren over welke datatypes geldig zijn</em>
      op een plaats in de broncode waar types staan. Generiek, want die regels zijn flexibeler en algemener dan ‘de
      class is exact
      <code class="lang-java">DezeClass</code>’. Bij Java kan je generic programming toepassen in definities van een
      method, class of interface.
    </p>
    <p class="bron">
      <a href="https://docs.oracle.com/javase/tutorial/java/generics/index.html">Lesson: Generics</a>
    </p>
    <p class="praktijk">
      Generic programming is nuttig om broncode algemener te maken, dus broncode beter herbruikbaar te maken. Denk
      bijvoorbeeld aan de volgende toepassingen:
    </p>
    <ul>
      <li>
        <p>
          Als je niet wilt casten naar een superklasse, zoals
          <code class="lang-java">Object</code>, maar ook niet een exact datatype kan gebruiken.
        </p>
      </li>
      <li>
        <p>
          Als een datastructuur alleen elementen van hetzelfde datatype bevat, kan je broncode eenvoudiger worden en kan
          je objectcode een hogere prestatie-efficiëntie leveren.
        </p>
      </li>
    </ul>
    <component-section>
      <div slot="title">Vergelijkbaarheid van classes met <code class="lang-java">Comparable</code></div>
      <p>
        <code class="lang-java">Comparable</code> is een generic interface in Java. Een class kan
        <code class="lang-java">Comparable</code> implementeren, om aan te geven hoe zijn objecten qua inhoud vergeleken
        worden met (andere) objecten.
      </p>
      <p class="bron">
        <a href="https://www.baeldung.com/java-comparator-comparable">Comparator and Comparable in Java</a>
        (negeer <code class="lang-java">Comparator</code> als je wilt).
      </p>
    </component-section>
  </component-section>
</component-section>
